function [ m,  signal ] = ComplexToneMistuned( t, fs, f0, arm, shift, noise, noiseFactor, phase, mHarm_num, mistProp )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

dt=1/fs;

m= (0:dt:t);

if strcmpi(phase, 'sine')
    signal= zeros(1,length(m));
    for i=arm(1):arm(2)
       if i==mHarm_num,
        signal= signal + sin(2*pi*((1+mistProp)*(i*f0)  + shift)*m);   
       else
        signal= signal + sin(2*pi*(i*f0 + shift)*m);
       end
    end
else if strcmpi(phase, 'rand')
    ph= (1/f0)*rand(1,1);
    signal= sin(2*pi*(arm(1)*f0)*(m-ph));
        for i=(arm(1)+1):arm(2)
            ph= (1/f0)*rand(1,1);
            signal= signal + sin(2*pi*(i*f0)*(m-ph));
        end   
    end
end
   signal= signal / max(signal);

   
   
   
%    Noise addition stage
   if strcmpi(noise,'white'),
       wnoise= randn(1,length(m));
       signal= signal + wnoise/noiseFactor;
   end
   if strcmpi(noise,'lowpass'),
        Wn= [(arm(1)-1)*f0/(fs/2)]; % Normalized cut-off frequencies
        n=2; % Order of the filter
        [b,a] = butter(n,Wn,'low'); 
        bnoise= randn(1,length(m));
        bnoise= filter(b,a,bnoise);
        signal= signal + bnoise/noiseFactor;
   end
   
end

