% Moore 1973: FDLs

clear;

% fs=44100;
fs=121100; % Does not work properly for 6300 Hz with standard 44100 Hz sampling frequency
dt=1/fs;
time=0.2;
t= (dt:dt:time);

f0s=[250, 500, 1000, 2000, 4000, 5000, 6300, 8000];
% f0s=[4000, 4500, 5000, 5500, 6000, 6300, 6800, 8000];
% f0s=[5500, 6000, 6200, 6300, 6450, 6700, 7000, 8000];

currentF= pwd;
currentF=currentF(1:length(currentF)-17);
currentF=strcat(currentF,'wavFileStore');

% delta_num=30;
delta_num=60;

deltas= GetDeltas(delta_num); % 30 values, log spaced in [0.001,0.3]

% PART 1: Produce reference pure tones
for i=1:8,
    f0=f0s(i);

    signal= sin(2*pi*f0*t);
    currentFolder = fullfile(currentF, 'FDLs', 'Ref');    
    name= strcat(num2str(1000+i),'PureTone(', num2str(f0), 'Hz)', num2str(floor(1000*time)), 'ms.wav');
    filename= fullfile(currentFolder, name);
    audiowrite(filename, signal, fs);
end


% PART 2: Produce tones with frequency alteration 
for i=1:8,
    for j=1:delta_num,
    f0=f0s(i)+f0s(i)*deltas(j);

    signal= sin(2*pi*f0*t);
    currentFolder = fullfile(currentF, 'FDLs', 'Deltas');    
    num= (i-1)*delta_num+j;
    name= strcat(num2str(1000+num),'PureTone(', num2str(round(f0)), 'Hz)', num2str(floor(10000*deltas(j))), 'd', num2str(floor(1000*time)), 'ms.wav');
    filename= fullfile(currentFolder, name);
    audiowrite(filename, signal, fs);
    end
end